package monnethic.mobile.homepage;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.example.monnthic.monnethicmobile.R;

import monnethic.mobile.user.UserAccountActivity;
import monnethic.mobile.wallet.WalletActivity;

public class LoginActivity extends AppCompatActivity {

    private EditText email;
    private EditText password;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);

        email = findViewById(R.id.editTextEmail);
        password = findViewById(R.id.editTextPassword);
        Button buttonCancel = findViewById(R.id.buttonCancel);
        Button buttonOk = findViewById(R.id.buttonOk);

        buttonCancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });
        buttonOk.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                validateInput();
            }
        });
    }

    public void onClickForgetPassword(View v){
        Toast.makeText(this, "Forget password", Toast.LENGTH_SHORT).show();
    }
    public void onClickForgetEmail(View v){
        Toast.makeText(this, "Forget email", Toast.LENGTH_SHORT).show();
    }
    private void validateInput(){
        if(InputController.isEmptyEdit(email)){
            Toast.makeText(this, "You did not enter your email", Toast.LENGTH_SHORT).show();
        } else if(!InputController.validEmail(email.getText().toString())){
            Toast.makeText(this, "Your email is invalid", Toast.LENGTH_SHORT).show();
        } else if(InputController.isEmptyEdit(password)) {
            Toast.makeText(this, "You did not enter your password", Toast.LENGTH_SHORT).show();
        } else {
            if(InputController.checkUser(email.getText().toString(),password.getText().toString())){
                launchWalletActivity(1);
            }else{
                Toast.makeText(this, "Wrong authentication", Toast.LENGTH_SHORT).show();
            }
        }
    }
    public void launchWalletActivity(int ldapId){
        //LAUNCH APP WALLET WITH ID USER
        Intent accountIntent = new Intent(LoginActivity.this, UserAccountActivity.class);
        accountIntent.putExtra("idUser", ldapId);
        LoginActivity.this.startActivity(accountIntent);
        finish();
    }
}
