package monnethic.mobile.transaction;

import com.j256.ormlite.field.DatabaseField;
import com.j256.ormlite.table.DatabaseTable;

import java.math.BigInteger;
import java.util.Date;

@DatabaseTable(tableName = "T_TRANSACTION")
public class Transaction {
    @DatabaseField(columnName = "transactionId", generatedId = true, unique = true)
    private int id;
    @DatabaseField(columnName = "transactionDate")
    private Date transactionDate;
    @DatabaseField(columnName = "transactionDSrcAddress")
    private String sourceAddress;
    @DatabaseField(columnName = "transactionDestAddress")
    private String destAddress;
    @DatabaseField(columnName = "transactionHash")
    private String transactionHash;
    @DatabaseField(columnName = "transactionBlockNumber")
    private String blockNumber;
    @DatabaseField(columnName = "transactionAmout")
    private BigInteger amount;
    @DatabaseField(columnName = "transactionUnit")
    private String unit;

    public Transaction() {
        super();
    }

    public Transaction(Date transactionDate, String sourceAddress, String destAddress, String transactionHash, String blockNumber, BigInteger amount, String unit) {
        super();
        this.transactionDate = transactionDate;
        this.sourceAddress = sourceAddress;
        this.destAddress = destAddress;
        this.transactionHash = transactionHash;
        this.blockNumber = blockNumber;
        this.amount = amount;
        this.unit = unit;
    }

    public String getSourceAddress() {
        return sourceAddress;
    }

    public void setSourceAddress(String sourceAddress) {
        this.sourceAddress = sourceAddress;
    }

    public String getDestAddress() {
        return destAddress;
    }

    public void setDestAddress(String destAddress) {
        this.destAddress = destAddress;
    }

    public String getTransactionHash() {
        return transactionHash;
    }

    public void setTransactionHash(String transactionHash) {
        this.transactionHash = transactionHash;
    }

    public BigInteger getAmount() {
        return amount;
    }

    public void setAmount(BigInteger amount) {
        this.amount = amount;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public Date getTransactionDate() {
        return transactionDate;
    }

    public void setTransactionDate(Date transactionDate) {
        this.transactionDate = transactionDate;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public String getBlockNumber() {
        return blockNumber;
    }

    public void setBlockNumber(String blockNumber) {
        this.blockNumber = blockNumber;
    }
}
