package monnethic.mobile.test.user;

import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.table.TableUtils;

import org.junit.Test;
import java.sql.Timestamp;
import monnethic.mobile.user.User;
import monnethic.mobile.user.UserDao;

public class UserDaoTest {
    private UserDao udao = new UserDao();
    private final String USER_EMAIL = "thomas.marshal@gmail.com";
    private final String USER_PASSWORD = "avcde";

    @Test
    public void TestACreateTable(){
        try{
            Dao<User, String> userDao;
            userDao = udao.createUserDaoConnection();
            TableUtils.createTable(userDao);
        }catch(Exception e){
            System.out.println(e.getMessage());
        }
    }

    @Test
    public void TestBInsertUser(){
        Timestamp timestamp = new Timestamp(System.currentTimeMillis());
        User user = new User("marshal","thomas",USER_EMAIL,USER_PASSWORD,timestamp.getTime(),timestamp.getTime(),false,false);
        try{
            udao.addUser(user);
        }catch(Exception e){
            System.out.println(e.getMessage());
        }
    }

    @Test
    public void TestCGetGeneratedUser(){
        try{
            User uTest = udao.getUser(USER_EMAIL);
            if(uTest==null){
                System.out.println("User don't Exist");
            }else {
                System.out.println(uTest.getEmail());
            }
        }catch(Exception e){
            System.out.println(e.getMessage());
        }
    }

    @Test
    public void TestDCheckApprovedUser(){
        try{
            boolean response = udao.checkApprovedUser(USER_EMAIL);
            if(response){
                System.out.println("Approved");
            }else{
                System.out.println("Not Approved");
            }
        }catch(Exception e){
            System.out.println(e.getMessage());
        }
    }

    @Test
    public void TestECheckVerifiedUser(){
        try{
            boolean response = udao.checkVerifiedUser(USER_EMAIL);
            if(response){
                System.out.println("Verified");
            }else{
                System.out.println("Not Verified");
            }
        }catch(Exception e){
            System.out.println(e.getMessage());
        }
    }

    @Test
    public void TestFCheckUserPassword(){
        try{
            boolean response = udao.checkUserPassword(USER_EMAIL,USER_PASSWORD);
            if(response){
                System.out.println("Password OK");
            }else{
                System.out.println("Password Failed");
            }
        }catch(Exception e){
            System.out.println(e.getMessage());
        }
    }

    @Test
    public void TestGUpdateUserPassword(){
        String newPassword = "newPassword";
        try{
            boolean response = udao.updateUserPassword(USER_EMAIL,newPassword);
            if(response){
                System.out.println("Password Changed");
            }else{
                System.out.println("Password Update Failed");
            }
        }catch(Exception e){
            System.out.println(e.getMessage());
        }
    }

    @Test
    public void TestHApproveVerifyUser(){
        try{
            udao.approveUser(USER_EMAIL);
            udao.verifyUser(USER_EMAIL);
        }catch(Exception e){
            System.out.println(e.getMessage());
        }
    }

    @Test
    public void TestICheckApprovedUser(){
        try{
            boolean response = udao.checkApprovedUser(USER_EMAIL);
            if(response){
                System.out.println("Approved");
            }else{
                System.out.println("Not Approved");
            }
        }catch(Exception e){
            System.out.println(e.getMessage());
        }
    }

    @Test
    public void TestJCheckVerifiedUser(){
        try{
            boolean response = udao.checkVerifiedUser(USER_EMAIL);
            if(response){
                System.out.println("Verified");
            }else{
                System.out.println("Not Verified");
            }
        }catch(Exception e){
            System.out.println(e.getMessage());
        }
    }

}
